// ctfbonus.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"
extern BZF_API bool bz_setPlayerWins(int,int);

BZ_GET_PLUGIN_VERSION

// event handler callback

class ctfbonus : public bz_EventHandler
{
public:
  ctfbonus();
  virtual ~ctfbonus();
  
  virtual void process ( bz_EventData *eventData );

  unsigned short capperCaptureBonus;
  unsigned short teamCaptureBonus;
};

ctfbonus ctfbonusHandler;
		
BZF_PLUGIN_CALL int bz_Load ( const char* commandLine )
{
  bz_debugMessage(1,"ctfbonus plugin loaded");
  unsigned short ccBonus = 5;
  if ( commandLine )
    ccBonus = (unsigned short)atoi(commandLine);
  ctfbonusHandler.capperCaptureBonus = ccBonus;
  ctfbonusHandler.teamCaptureBonus = 2;
  bz_registerEvent(bz_eCaptureEvent,&ctfbonusHandler);

  return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{
  bz_removeEvent(bz_eCaptureEvent,&ctfbonusHandler);
  bz_debugMessage(1,"ctfbonus plugin unloaded");
  return 0;
}

ctfbonus::ctfbonus()
{
}

ctfbonus::~ctfbonus()
{
}

void ctfbonus::process ( bz_EventData *eventData )
{
  switch (eventData->eventType)
  {
  default:
    break;
  case bz_eCaptureEvent:
    {
      bz_CTFCaptureEventData	*ctfEvent = (bz_CTFCaptureEventData*)eventData;
      bz_PlayerRecord *playerData = bz_getPlayerByIndex(ctfEvent->playerCapping);
      bz_PlayerRecord *teamPlayerData;

      // Check for NULL coming back from getPlayerByIndex
      if (!playerData)
	return;
      // Add bonus points only for a team player, not rogue.
      if (ctfEvent->teamCapped != playerData->team) {
	if (capperCaptureBonus) {
	  bz_setPlayerWins(ctfEvent->playerCapping, playerData->wins+capperCaptureBonus);
	}
	// Add bonus points for the team's player
	if (teamCaptureBonus) {
          bz_debugMessagef(1,"ctfbonus in teamCaptureBonus, capper is %d", ctfEvent->playerCapping);
	  bzAPIIntList *playerList = bz_newIntList();
	  bz_getPlayerIndexList (playerList);
	  for ( unsigned int i = 0; i<playerList->size(); i++) {
	   teamPlayerData = bz_getPlayerByIndex(playerList->get(i));
	   if (teamPlayerData == NULL)
	     continue;
	   bz_debugMessagef(1,"ctfbonus using %d index",playerList->get(i));
	   if ((ctfEvent->teamCapping != teamPlayerData->team) ||
	     (ctfEvent->playerCapping == playerList->get(i))) {
	     bz_freePlayerRecord(teamPlayerData);
	     continue;
	   }
	   bz_setPlayerWins(playerList->get(i),teamPlayerData->wins+teamCaptureBonus);
	   bz_freePlayerRecord(teamPlayerData);
	  }
	  bz_deleteIntList(playerList);
	}
      }
      bz_freePlayerRecord(playerData);
    }
    break;
  }
}

// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8

